package xhttp3.internal.http;

import java.net.ProtocolException;
import xhttp3.Interceptor;
import xhttp3.Request;
import xhttp3.Response;
import xhttp3.internal.connection.StreamAllocation;
import xio.BufferedSink;
import xio.Okio;

public final class CallServerInterceptor implements Interceptor {
   private final boolean forWebSocket;

   public CallServerInterceptor(boolean forWebSocket) {
      this.forWebSocket = forWebSocket;
   }

   public Response intercept(Interceptor.Chain chain) {
      RealInterceptorChain var2;
      HttpStream var3;
      HttpStream var10000 = var3 = (var2 = (RealInterceptorChain)chain).httpStream();
      Interceptor.Chain var10001 = chain;
      StreamAllocation chain1 = var2.streamAllocation();
      Request var9;
      Request var12 = var9 = var10001.request();
      long var4 = System.currentTimeMillis();
      var10000.writeRequestHeaders(var12);
      if (HttpMethod.permitsRequestBody(var9.method()) && var9.body() != null) {
         BufferedSink var10 = Okio.buffer(var3.createRequestBody(var9, var9.body().contentLength()));
         var9.body().writeTo(var10);
         var10.close();
      }

      CallServerInterceptor var11 = this;
      var3.finishRequest();
      Response var6 = var3.readResponseHeaders().request(var9).handshake(chain1.connection().handshake()).sentRequestAtMillis(var4).receivedResponseAtMillis(System.currentTimeMillis()).build();
      if (!var11.forWebSocket || var6.code() != 101) {
         var6 = var6.newBuilder().body(var3.openResponseBody(var6)).build();
      }

      if ("close".equalsIgnoreCase(var6.request().header("Connection")) || "close".equalsIgnoreCase(var6.header("Connection"))) {
         chain1.noNewStreams();
      }

      int chain2;
      if (((chain2 = var6.code()) == 204 || chain2 == 205) && var6.body().contentLength() > 0L) {
         throw new ProtocolException("HTTP " + chain2 + " had non-zero Content-Length: " + var6.body().contentLength());
      } else {
         return var6;
      }
   }
}
